                                                                                                                                                                                                                                /*
 * LimeSurvey
 * Copyright (C) 2007 The LimeSurvey Project Team / Carsten Schmitz
 * All rights reserved.
 * License: GNU/GPL License v2 or later, see LICENSE.php
 * LimeSurvey is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 * 
 * 
 * Description: Javascript file for templates. Put JS-functions for your template here.
 *  
 * 
 * $Id:$
 */

/*
 * The function rfs_nav_delay waits n seconds before enabling the next key 
 * 
 * uses same methods as normal LS. For including per question,
 */
function rfs_nav_delay(n)
{
	$(document).ready(function() {
		$('#movenextbtn').attr('disabled', 'disabled'); 
		$('#movenextbtn').attr('aria-disabled', true);
		$('#movenextbtn').button("disable");
		navigator_countdown(n); 
		//navigator_countdown(1); 
	

		//$('#movenextbtn').hide();
		//Show the next button when a radio is clicked
		// use click_required so doesn't break if rfs_nav is not called.
		$(window).data('rfs_click_required',1);
		$('input.radio').click(function(){
			$(window).data('rfs_click_required', null);
			if (!$(window).data('countdown')) {
				$('#movenextbtn').attr('aria-disabled', false);
				$('#movenextbtn').button("option", "disabled", false);
			};
		});
	});
}

// RFS added the rfs_clicked state to check if a button has been clicked.
// logic is a bit about dace so that surveys that don't set it are not affected
function navigator_countdown_end()
{
	if (!$(window).data('rfs_click_required')) {
		navigator_countdown_btn().each(function(i, e)
		{
			e.value = $(e).data('text');
			$(e).button("option", "disabled", false);
			$(e).attr('aria-disabled','false');
		});
		$(window).data('countdown', null);
	}
}


/*
 * The function focusFirst puts the Focus on the first non-hidden element in the Survey. 
 * 
 * Normally this is the first input field (the first answer).
 */
function focusFirst(Event)
{
	var i=0;
	// count up as long as the elements are hidden
	while(document.forms[0].elements[i].type == "hidden" &&
		document.forms[0].elements[i].style.visibility == 'visible')
	{
		i++;
	}
	// put focus on the element we just counted.
	if (document.forms[0].elements[i].type == "hidden" &&
		document.forms[0].elements[i].style.visibility == 'visible')
	{
		document.forms[0].elements[i].focus();
	}
	return;
}
/*
 * The focusFirst function is added to the eventlistener, when the page is loaded.
 * 
 * This can be used to start other functions on pageload as well. Just put it inside the 'ready' function block
 */

/** Uncomment if you want to use the focusFirst function

$(document).ready(function(){
   focusFirst();
})
	
**/



function correctPNG() // correctly handle PNG transparency in Win IE 5.5 & 6.
{
   var arVersion = navigator.appVersion.split("MSIE")
   var version = parseFloat(arVersion[1])
   if ((version >= 5.5) && (version<7) && (document.body.filters)) 
   {
      for(var i=0; i<document.images.length; i++)
      {
         var img = document.images[i]
         var imgName = img.src.toUpperCase()
         if (imgName.substring(imgName.length-3, imgName.length) == "PNG")
         {
            var imgID = (img.id) ? "id='" + img.id + "' " : "";
            var imgClass = (img.className) ? "class='" + img.className + "' " : "";
            var imgTitle = (img.title) ? "title='" + img.title + "' " : "title='" + img.alt + "' ";
            var imgStyle = "display:inline-block;" + img.style.cssText;
            if (img.align == "left") imgStyle = "float:left;" + imgStyle;
            if (img.align == "right") imgStyle = "float:right;" + imgStyle;
            if (img.parentElement.href) imgStyle = "cursor:hand;" + imgStyle;
            var strNewHTML = "<span " + imgID + imgClass + imgTitle
            + " style=\"" + "width:" + img.width + "px; height:" + img.height + "px;" + imgStyle + ";"
            + "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader"
            + "(src='" + img.src + "', sizingMethod='scale');\"></span>" 
            img.outerHTML = strNewHTML
            i = i-1
         }
      }
   }    
}                           


           /* - - - The following code is to hide first and last name input in open token mode - - - */
           
           $(document).ready(function() { 
 
    // Only if the registration form exists...
    if($('table.register').length > 0) {
 
		// Hide the name input rows
		$('input[name="register_firstname"], input[name="register_lastname"]').closest('tr').hide();
	}
});

 /* - - - - -  KEYPAD - - - - - */
/*
$(document).ready(function() {
 
    	// Set up the spacer for the top keyboard row
		var spacer = $.keypad.HALF_SPACE;
		for(var i = 0; i != 8; ++i) spacer += $.keypad.SPACE;
 
		// Apply the virtual keyboard to all text inputs and textareas
		$('input.text, textarea').keypad({
			showAnim: 'fadeIn',
			keypadOnly: false,
			layout: [
				spacer + $.keypad.CLEAR + $.keypad.CLOSE, $.keypad.SPACE,
				$.keypad.BACK,
				$.keypad.HALF_SPACE,
                $.keypad.SPACE + '0123' + $.keypad.SPACE_BAR,
				$.keypad.ENTER
				]
		});
 
	});
    
$(document).ready(function() {
 
    	// Set up the spacer for the top keyboard row
		var spacer = $.keypad.HALF_SPACE;
		for(var i = 0; i != 8; ++i) spacer += $.keypad.SPACE;
 
		// Apply the virtual keyboard to all text inputs and textareas
		$('input.text, textarea').keypad({
			showAnim: 'fadeIn',
			keypadOnly: false,
			layout: [
				spacer + $.keypad.CLEAR + $.keypad.CLOSE, $.keypad.SPACE,
				'!@#$%^&*()_=' + $.keypad.HALF_SPACE + $.keypad.BACK,
				$.keypad.HALF_SPACE + '`~[]{}<>\\|/' + $.keypad.SPACE + $.keypad.SPACE + '789',
				'qwertyuiop\'"' + $.keypad.HALF_SPACE + $.keypad.SPACE + '456',
				$.keypad.HALF_SPACE + 'asdfghjkl;:' + $.keypad.SPACE + $.keypad.SPACE + '123',
				$.keypad.SPACE + 'zxcvbnm,.?' + $.keypad.SPACE + $.keypad.SPACE + $.keypad.HALF_SPACE + '-0+',
				$.keypad.SHIFT + $.keypad.SPACE_BAR + $.keypad.ENTER
				]
		});
 
	});
*/
    
$(document).ready(function() {
	if($('#ZahlenanzeigeMixo').length > 0) {
		
		// Identify some elements
		var thisQuestion = $('#ZahlenanzeigeMixo').closest('div[id^="question"]');
		var thisInput = $('input[type="text"]', thisQuestion);
		
		// Click events for buttons
		$('.questiontext button', thisQuestion).on('click', function(e) {
			if($(this).attr('data-function') == 'button-press') {
				buttonPress($(this).attr('data-value'));
			}
			if($(this).attr('data-function') == 'replay') {
				replay();
			}
		});
		
        // Variablen definieren
        var audio = new Audio(),
            srcList = [
                null,
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoD.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoE.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoFis.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoGis.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoA.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoH.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/MixoC.mp3'
            ],
            audioIndex = 1,
            timeoutReplay = 0,
            timeoutReplayPause = 500,
            zahlen = [];


        // Array zahlen abspielen
        function replay() {
            if (document.getElementById('ZahlenanzeigeMixo').dataset.status !== 'ready') {
                return;
            }

            if (typeof zahlen[audioIndex] !== 'undefined') {
                if (zahlen[audioIndex] == 0) {
                    audioIndex = audioIndex + 1;
                    setTimeout(replay, timeoutReplayPause);
                } else {
                    document.getElementById('ZahlenanzeigeMixo').dataset.status = 'playing';
                    audio.onended = null;
                    audio.src = srcList[zahlen[audioIndex]];
                    audio.onended = function () {
                        audioIndex = audioIndex + 1;
                        audio.onended = null;
                        document.getElementById('ZahlenanzeigeMixo').dataset.status = 'ready';
                        setTimeout(replay, timeoutReplay);
                    };
                    audio.play();
                }
            } else {
                audioIndex = 0;
                audio.onended = null;
                document.getElementById('ZahlenanzeigeMixo').dataset.status = 'ready';
            }
        }

        // Audio abspielen
        function playAudio() {
            document.getElementById('ZahlenanzeigeMixo').dataset.status = 'playing';
            audio.onended = null;
            audio.src = srcList[audioIndex];
            audio.onended = function () {
                audioIndex = 0;
                audio.onended = null;
                document.getElementById('ZahlenanzeigeMixo').dataset.status = 'ready';
            };
            audio.play();
        }


        // Schalter verarbeiten
        function buttonPress(value) {
            if (document.getElementById('ZahlenanzeigeMixo').dataset.status === 'ready') {
                switch (Number(value)) {
                case -1:
                    zahlen.pop();
                    document.getElementById("ZahlenanzeigeMixo").innerHTML = zahlen.join('');
                    break;
                case 0:
                    audioIndex = value;
                    zahlen.push(value);
                    break;
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                    audioIndex = value;
                    zahlen.push(value);
                    playAudio(value);
                    break;
                }
                document.getElementById('ZahlenanzeigeMixo').innerHTML = zahlen.join('');
				thisInput.val(document.getElementById('ZahlenanzeigeMixo').innerHTML.replace(/\s+/g, '').replace(/-/g, ''));
            }
        }


        // Audio Dateien laden
        audio.addEventListener('canplaythrough', preLoadAudio, false);
        function preLoadAudio() {
            if (typeof srcList[audioIndex] !== 'undefined') {
                audio.src = srcList[audioIndex];
                audioIndex = audioIndex + 1;
            } else {
                audioIndex = 0;
                document.getElementById('ZahlenanzeigeMixo').innerHTML = '';
				thisInput.val(document.getElementById('ZahlenanzeigeMixo').innerHTML.replace(/\s+/g, '').replace(/-/g, ''));
                document.getElementById('ZahlenanzeigeMixo').dataset.status = 'ready';
                audio.removeEventListener('canplaythrough', preLoadAudio, false);
            }
        }


        // Initialisierung
        function init() {
            document.getElementById('ZahlenanzeigeMixo').innerHTML = 'Lade Audiodaten...';
            preLoadAudio();

            document.onkeydown = function(event) {
                var charCode = event.which || event.keyCode;

                switch (charCode) {
                    case 220:
                        buttonPress(0);
                        break;
                    case 49:              // 1
                        buttonPress(1);
                        break;
                    case 50:              // 2
                        buttonPress(2);
                        break;
                    case 51:              // 3
                        buttonPress(3);
                        break;
                    case 52:              // 4
                        buttonPress(4);
                        break;
                    case 53:              // 5
                        buttonPress(5);
                        break;
                    case 54:              // 6
                        buttonPress(6);
                        break;
                    case 55:              // 7
                        buttonPress(7);
                        break;
                    case 32:              // spacebar
                        replay();
                        break;
                    case 8:              // backspace
                        buttonPress(-1);
                        break;
                }
            }
       }

        init();
	}
 
});

$(document).ready(function() {
    if($('#ZahlenanzeigeDorisch').length > 0) {
		
		// Identify some elements
		var thisQuestion = $('#ZahlenanzeigeDorisch').closest('div[id^="question"]');
		var thisInput = $('input[type="text"]', thisQuestion);
		
		// Click events for buttons
		$('.questiontext button', thisQuestion).on('click', function(e) {
			if($(this).attr('data-function') == 'button-press') {
				buttonPress($(this).attr('data-value'));
			}
			if($(this).attr('data-function') == 'replay') {
				replay();
			}
		});
		
        // Variablen definieren
        var audio = new Audio(),
            srcList = [
                null,
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischA.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischH.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischC.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischDis.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischE.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischFis.mp3',
                'https://www2.uibk.ac.at/downloads/c7201049/mct/DorischG.mp3'
            ],
            audioIndex = 1,
            timeoutReplay = 0,
            timeoutReplayPause = 500,
            zahlen = [];


        // Array zahlen abspielen
        function replay() {
            if (document.getElementById('ZahlenanzeigeDorisch').dataset.status !== 'ready') {
                return;
            }

            if (typeof zahlen[audioIndex] !== 'undefined') {
                if (zahlen[audioIndex] == 0) {
                    audioIndex = audioIndex + 1;
                    setTimeout(replay, timeoutReplayPause);
                } else {
                    document.getElementById('ZahlenanzeigeDorisch').dataset.status = 'playing';
                    audio.onended = null;
                    audio.src = srcList[zahlen[audioIndex]];
                    audio.onended = function () {
                        audioIndex = audioIndex + 1;
                        audio.onended = null;
                        document.getElementById('ZahlenanzeigeDorisch').dataset.status = 'ready';
                        setTimeout(replay, timeoutReplay);
                    };
                    audio.play();
                }
            } else {
                audioIndex = 0;
                audio.onended = null;
                document.getElementById('ZahlenanzeigeDorisch').dataset.status = 'ready';
            }
        }

        // Audio abspielen
        function playAudio() {
            document.getElementById('ZahlenanzeigeDorisch').dataset.status = 'playing';
            audio.onended = null;
            audio.src = srcList[audioIndex];
            audio.onended = function () {
                audioIndex = 0;
                audio.onended = null;
                document.getElementById('ZahlenanzeigeDorisch').dataset.status = 'ready';
            };
            audio.play();
        }


        // Schalter verarbeiten
        function buttonPress(value) {
            if (document.getElementById('ZahlenanzeigeDorisch').dataset.status === 'ready') {
                switch (Number(value)) {
                case -1:
                    zahlen.pop();
                    document.getElementById("ZahlenanzeigeDorisch").innerHTML = zahlen.join('');
                    break;
                case 0:
                    audioIndex = value;
                    zahlen.push(value);
                    break;
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                    audioIndex = value;
                    zahlen.push(value);
                    playAudio(value);
                    break;
                }
                document.getElementById('ZahlenanzeigeDorisch').innerHTML = zahlen.join('');
				thisInput.val(document.getElementById('ZahlenanzeigeDorisch').innerHTML.replace(/\s+/g, '').replace(/-/g, ''));
            }
        }


        // Audio Dateien laden
        audio.addEventListener('canplaythrough', preLoadAudio, false);
        function preLoadAudio() {
            if (typeof srcList[audioIndex] !== 'undefined') {
                audio.src = srcList[audioIndex];
                audioIndex = audioIndex + 1;
            } else {
                audioIndex = 0;
                document.getElementById('ZahlenanzeigeDorisch').innerHTML = '';
				thisInput.val(document.getElementById('ZahlenanzeigeDorisch').innerHTML.replace(/\s+/g, '').replace(/-/g, ''));
                document.getElementById('ZahlenanzeigeDorisch').dataset.status = 'ready';
                audio.removeEventListener('canplaythrough', preLoadAudio, false);
            }
        }


        // Initialisierung
        function init() {
            document.getElementById('ZahlenanzeigeDorisch').innerHTML = 'Lade Audiodaten...';
            preLoadAudio();

            document.onkeydown = function(event) {
                var charCode = event.which || event.keyCode;

                switch (charCode) {
                    case 220:
                        buttonPress(0);
                        break;
                    case 49:              // 1
                        buttonPress(1);
                        break;
                    case 50:              // 2
                        buttonPress(2);
                        break;
                    case 51:              // 3
                        buttonPress(3);
                        break;
                    case 52:              // 4
                        buttonPress(4);
                        break;
                    case 53:              // 5
                        buttonPress(5);
                        break;
                    case 54:              // 6
                        buttonPress(6);
                        break;
                    case 55:              // 7
                        buttonPress(7);
                        break;
                    case 32:              // spacebar
                        replay();
                        break;
                    case 8:              // backspace
                        buttonPress(-1);
                        break;
                }
            }
       }

        init();
	}
 
});